net.sf.saxon.functions

## Class SystemFunctionLibrary

- java.lang.Object
- - net.sf.saxon.functions.SystemFunctionLibrary

- All Implemented Interfaces:
    Serializable, FunctionLibrary

      public class SystemFunctionLibrary
      extends Object
      implements FunctionLibrary

  The SystemFunctionLibrary represents the collection of functions in the fn: namespace. That is, the functions defined in the "Functions and Operators" specification, optionally augmented by the additional functions defined in XSLT.
  See Also:
    Serialized Form

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Expression` | `bind(StructuredQName functionName, int arity, Expression[] staticArgs, StaticContext env, Container container)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `FunctionItem` | `getFunctionItem(StructuredQName functionName, int arity, StaticContext staticContext)` Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `static SystemFunctionLibrary` | `getSystemFunctionLibrary(int functionSet)` Factory method to create or get a SystemFunctionLibrary
    `boolean` | `isAvailable(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getSystemFunctionLibrary

          public static SystemFunctionLibrary getSystemFunctionLibrary(int functionSet)

      Factory method to create or get a SystemFunctionLibrary
      Parameters:
        `functionSet` - determines the set of functions allowed. One or more of the bit settings `StandardFunction.CORE`, `StandardFunction.XSLT`, `StandardFunction.XQUPDATE`, etc
      Returns:
        the appropriate SystemFunctionLibrary

    - #### bind

          public Expression bind(StructuredQName functionName,
                        int arity,
                        Expression[] staticArgs,
                        StaticContext env,
                        Container container)
                          throws XPathException

      Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the name of the function to be bound
        `arity` -
        `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
        `env` -
        `container` -
      Returns:
        An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.
      Throws:
        `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function; or if this function library "owns" the namespace containing the function call, but no function was found.

    - #### getFunctionItem

          public FunctionItem getFunctionItem(StructuredQName functionName,
                                     int arity,
                                     StaticContext staticContext)
                                       throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `arity` - The number of arguments.
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable(StructuredQName functionName,
                            int arity)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `arity` - The number of arguments.
      Returns:
        true if a function of this name and arity is available for calling

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.